package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLVal_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLVal extends JNIObject  {
	
	/* @generated */
	protected ISLVal(long ptr) {
		/*** PROTECTED REGION ID(ISLVal_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLVal build(long ptr) {
		return new ISLVal(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLVal_userCode) ENABLED START ***/
	public static ISLVal buildRationalValue(ISLContext ctx, long n, long d) {
		ISLVal num = ISLVal.buildFromLong(ctx, n);
		ISLVal den = ISLVal.buildFromLong(ctx, d);
		
		return num.div(den);
	}
	
	public long asLong() {
		if (isInteger()) {
			return getNumerator();
		}
		
		throw new RuntimeException("val: " + this + " is not an integer");
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_val_zero 
	 * 
	 * @generated
	**/
	 public static ISLVal buildZero(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_val_zero) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_val_zero(getNativePtr(ctx)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_int_from_si 
	 * 
	 * @generated
	**/
	 public static ISLVal buildFromLong(ISLContext ctx, long i) { 
		/*** PROTECTED REGION ID(static_isl_val_int_from_si) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_val_int_from_si(getNativePtr(ctx), i));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_read_from_str 
	 * 
	 * @generated
	**/
	 public static ISLVal buildFromString(ISLContext ctx, String str) { 
		/*** PROTECTED REGION ID(static_isl_val_read_from_str) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_val_read_from_str(getNativePtr(ctx), str));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_to_string 
	 * 
	 * @generated
	**/
	 public static String _toString(ISLVal val, int format) { 
		/*** PROTECTED REGION ID(static_isl_val_to_string) DISABLED START ***/
		String res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_to_string(getNativePtr(val), format);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_val_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_val_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_val_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_copy 
	 * 
	 * @generated
	**/
	public ISLVal copy() {
		/*** PROTECTED REGION ID(isl_val_copy) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLVal.build(ISLNative.isl_val_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_val_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_val_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_set_si 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal setValue(long i) {
		/*** PROTECTED REGION ID(isl_val_set_si) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_val_set_si(getNativePtr(this), i));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_get_num_si 
	 * 
	 * @generated
	**/
	public long getNumerator() {
		/*** PROTECTED REGION ID(isl_val_get_num_si) DISABLED START ***/
		long res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_get_num_si(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_get_den_si 
	 * 
	 * @generated
	**/
	public long getDenominator() {
		/*** PROTECTED REGION ID(isl_val_get_den_si) DISABLED START ***/
		long res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_get_den_si(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_get_d 
	 * 
	 * @generated
	**/
	public double getDoubleValue() {
		/*** PROTECTED REGION ID(isl_val_get_d) DISABLED START ***/
		double res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_get_d(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_sgn 
	 * 
	 * @generated
	**/
	public int sign() {
		/*** PROTECTED REGION ID(isl_val_sgn) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_sgn(getNativePtr(this));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_zero 
	 * 
	 * @generated
	**/
	public boolean isZero() {
		/*** PROTECTED REGION ID(isl_val_is_zero) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_zero(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_one 
	 * 
	 * @generated
	**/
	public boolean isOne() {
		/*** PROTECTED REGION ID(isl_val_is_one) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_one(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_negone 
	 * 
	 * @generated
	**/
	public boolean isNegOne() {
		/*** PROTECTED REGION ID(isl_val_is_negone) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_negone(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_nonneg 
	 * 
	 * @generated
	**/
	public boolean isNonNegative() {
		/*** PROTECTED REGION ID(isl_val_is_nonneg) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_nonneg(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_nonpos 
	 * 
	 * @generated
	**/
	public boolean isNonPositive() {
		/*** PROTECTED REGION ID(isl_val_is_nonpos) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_nonpos(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_pos 
	 * 
	 * @generated
	**/
	public boolean isPositive() {
		/*** PROTECTED REGION ID(isl_val_is_pos) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_pos(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_neg 
	 * 
	 * @generated
	**/
	public boolean isNegative() {
		/*** PROTECTED REGION ID(isl_val_is_neg) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_neg(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_int 
	 * 
	 * @generated
	**/
	public boolean isInteger() {
		/*** PROTECTED REGION ID(isl_val_is_int) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_int(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_rat 
	 * 
	 * @generated
	**/
	public boolean isRational() {
		/*** PROTECTED REGION ID(isl_val_is_rat) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_rat(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_nan 
	 * 
	 * @generated
	**/
	public boolean isNaN() {
		/*** PROTECTED REGION ID(isl_val_is_nan) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_nan(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_infty 
	 * 
	 * @generated
	**/
	public boolean isInfinity() {
		/*** PROTECTED REGION ID(isl_val_is_infty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_infty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_neginfty 
	 * 
	 * @generated
	**/
	public boolean isNegInfinity() {
		/*** PROTECTED REGION ID(isl_val_is_neginfty) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_neginfty(getNativePtr(this)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_lt 
	 * 
	 * @generated
	**/
	public boolean lt(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_lt) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_lt(getNativePtr(this), getNativePtr(v2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_le 
	 * 
	 * @generated
	**/
	public boolean le(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_le) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_le(getNativePtr(this), getNativePtr(v2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_gt 
	 * 
	 * @generated
	**/
	public boolean gt(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_gt) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_gt(getNativePtr(this), getNativePtr(v2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_ge 
	 * 
	 * @generated
	**/
	public boolean ge(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_ge) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_ge(getNativePtr(this), getNativePtr(v2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_eq 
	 * 
	 * @generated
	**/
	public boolean eq(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_eq) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_eq(getNativePtr(this), getNativePtr(v2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_ne 
	 * 
	 * @generated
	**/
	public boolean ne(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_ne) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_ne(getNativePtr(this), getNativePtr(v2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_is_divisible_by 
	 * 
	 * @generated
	**/
	public boolean isDivisibleBy(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_is_divisible_by) DISABLED START ***/
		boolean res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_is_divisible_by(getNativePtr(this), getNativePtr(v2)) != 0;
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_cmp_si 
	 * 
	 * @generated
	**/
	public int compareTo(long i) {
		/*** PROTECTED REGION ID(isl_val_cmp_si) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_val_cmp_si(getNativePtr(this), i);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_abs 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal abs() {
		/*** PROTECTED REGION ID(isl_val_abs) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_val_abs(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_neg 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal neg() {
		/*** PROTECTED REGION ID(isl_val_neg) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_val_neg(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_floor 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal floor() {
		/*** PROTECTED REGION ID(isl_val_floor) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_val_floor(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_ceil 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal ceil() {
		/*** PROTECTED REGION ID(isl_val_ceil) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_val_ceil(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_trunc 
	 * 
	 * @take this
	 * @generated
	**/
	public ISLVal trunc() {
		/*** PROTECTED REGION ID(isl_val_trunc) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				res = ISLVal.build(ISLNative.isl_val_trunc(getNativePtr(this)));
			} finally {
				taken(this);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_min 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal min(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_min) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_min(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_max 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal max(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_max) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_max(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_add 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal add(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_add) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_add(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_sub 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal sub(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_sub) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_sub(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_mul 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal mul(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_mul) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_mul(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_div 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal div(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_div) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_div(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_mod 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal mod(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_mod) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_mod(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_val_gcd 
	 * 
	 * @take this v2
	 * @generated
	**/
	public ISLVal gcd(ISLVal v2) {
		/*** PROTECTED REGION ID(isl_val_gcd) DISABLED START ***/
		ISLVal res;
		
		synchronized(LOCK) {
			checkParameters(this, v2);
			try {
				res = ISLVal.build(ISLNative.isl_val_gcd(getNativePtr(this), getNativePtr(v2)));
			} finally {
				taken(this);
				taken(v2);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLVal_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
